<template>
  <div :class="className" :style="{height:height,width:width}" />
</template>

<script>
import echarts from 'echarts'
require('echarts/theme/macarons') // echarts theme
import resize from '../mixins/resize'
import {trainCount} from "@/api/common/homedataCbpb";

export default {
  mixins: [resize],
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    width: {
      type: String,
      default: '100%'
    },
    height: {
      type: String,
      default: '210px'
    }
  },
  data() {
    return {
      chart: null,
      trainData:[],
      trainingType:[]
    }
  },
  mounted() {
    this.$nextTick(() => {
      trainCount().then(res=>{
        for (const item of res.data) {
          this.trainData.push({value:item.trainingTypeCount,name:item.trainingType});
          this.trainingType.push(item.trainingType)
        }
        this.initChart()
      })
    })
  },
  beforeDestroy() {
    if (!this.chart) {
      return
    }
    this.chart.dispose()
    this.chart = null
  },
  methods: {
    initChart() {
      this.chart = echarts.init(this.$el, 'macarons')

      this.chart.setOption({
        tooltip: {
          trigger: 'item',
          formatter: '{a} <br/>{b} : {c} ({d}%)'
        },
        legend: {
          left: 'center',
          bottom: '10',
          data:this.trainingType
        },
        series: [
          {
            name: '',
            type: 'pie',
            roseType: 'radius',
            radius: ['10%', '55%'],
            center: ['50%', '38%'],
            data: this.trainData,
            animationEasing: 'cubicInOut',
            animationDuration: 2600
          }
        ]
      })
    }
  }
}
</script>
